/*
 *	The node types for the first byte in any node
 */

/* macro arguments
 * $1 - name of node
 * $2 - print code
 * $3 - flags for the node
 * $4 - number of tree-type children for the node
 * $5 - number of total children for the node
 */


#include "nc.h"
struct node_info node_table[] = {
 {"", 0, 0, 0 },
 {"", 0, 0, 0 },
 {"extern !0d;", 0, 1, 1 },
 {"extern !0d();", 0, 2, 2 },
 {"!0d;", 0, 1, 1 },
 {"!0i", 0, 0, 1 },
 {"!0l\n!1l", 0, 2, 2 },
 {"!0t : !1t", 0, 2, 2 },
 {"case !0t :\n!1t", 0, 2, 2 },
 {"default:\n!0t", 0, 1, 1 },
 {"{\n!0l\n}", 0, 1, 1 },
 {"!0t;", 0, 1, 1 },
 {"score += (!0t);", 0, 1, 1 },
 {"", 0, 2, 2 },
 {"!0t = !1t", 0, 2, 2 },
 {"if( !0t )!>\n!1t!<", 0, 2, 2 },
 {"if( !0t )!>\n!1t!<\nelse!>\n!2t!<", TF_ONEINT, 3, 3 },
 {"switch( !0t ) !>\n!1t!<", TF_ONEINT, 2, 2 },
 {"while( !0t )!>\n!1t!<", TF_ONEINT, 2, 2 },
 {"for( !0t; !1t; !2t ) !>\n!3t!<", 0, 4, 4 },
 {"", 0, 3, 3 },
 {"goto !0t;", 0, 1, 1 },
 {"continue;", 0, 0, 0 },
 {"break;", 0, 0, 0 },
 {"return !0t;", 0, 1, 1 },
 {"return score = Accept;", TF_RET, 0, 0 },
 {"{if( !0t ) return score = Accept;}", TF_ONEINT|TF_RET, 1, 1 },
 {"return score = Reject;", TF_RET, 0, 0 },
 {"{if( !0t ) return score = Reject;}", TF_ONEINT|TF_RET, 1, 1 },
 {"!0t->vals[!1t]", 0, 2, 2 },
 {"!0t(!1,)", 0, 2, 2 },
 {"!0N", 0, 0, 1 },
 {"!0$", 0, 0, 1 },
 {"!0n", 0, 0, 1 },
 {"gquery(!0n)", TF_RETINT, 0, 1 },
 {"(!0t)", 0, 1, 1 },
 {"!0t++", 0, 1, 1 },
 {"!0t--", 0, 1, 1 },
 {"++!0t", 0, 1, 1 },
 {"--!0t", 0, 1, 1 },
 {"+!0t", TF_ONEINT, 1, 1},
 {"-!0t", TF_ONEINT, 1, 1 },
 {"!!!0t", TF_ONEINT|TF_RETINT, 1, 1 },
 {"!0t*!1t", TF_2INT, 2, 2 },
 {"!0t/!1t", TF_2INT, 2, 2 },
 {"!0t%!1t", TF_2INT, 2, 2 },
 {"!0t + !1t", TF_2INT, 2, 2 },
 {"!0t - !1t", TF_2INT, 2, 2 },
 {"!0t < !1t", TF_2INT|TF_RETINT, 2, 2 },
 {"!0t > !1t", TF_2INT|TF_RETINT, 2, 2 },
 {"!0t <= !1t", TF_2INT|TF_RETINT, 2, 2 },
 {"!0t >= !1t", TF_2INT|TF_RETINT, 2, 2 },
 {"", TF_RETINT, 2, 2 },
 {"", TF_RETINT, 2, 2 },
 {"", TF_RETINT, 2, 2 },
 {"", TF_RETINT, 2, 2 },
 {"", TF_RETINT, 2, 2 },
 {"", TF_RETINT, 2, 2 },
 {"!0t & !1t", TF_2INT, 2, 2 },
 {"!0t | !1t", TF_2INT, 2, 2 },
 {"!0t && !1t", TF_2INT|TF_RETINT, 2, 2 },
 {"!0t ^ !1t", TF_2INT, 2, 2 },
 {"!0t || !1t", TF_2INT|TF_RETINT, 2, 2 },
 {"!0t ? !1t : !2t", 0, 3, 3 },
 {"!0P", 0, 0, 1 },
 {"", 0, 3, 3 },
 {"", 0, 2, 2 },

 };

